; wsp V1.6 by Vortex - simple wsprintf emulator for NULL terminated strings
; Return value : eax holds the length of the string in the buffer

.386
.model flat,stdcall
option casemap:none

.data

wsp_table   db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
            db 0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
            db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
            db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
            db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
            db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
            db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
            db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.code

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

wsp PROC C buffer:DWORD,format:DWORD,args:VARARG
	
    push    esi
    push    edi
    push    ebx
    push    ebp
    mov     edx,1
    mov     edi,DWORD PTR [esp+20]  ; buffer
    mov     esi,DWORD PTR [esp+24]  ; format
    lea     ebx,DWORD PTR [esp+28]  ; args
    sub     edi,edx
    mov     ebp,OFFSET wsp_table
    sub     esi,edx
@@:
    add     edi,edx

_wsp1:

    add     esi,edx
    movzx   eax,BYTE PTR [esi]
    mov     BYTE PTR [edi],al
    cmp     BYTE PTR [ebp+eax],dl
    jne     @b
    test    eax,eax
    jnz     @f
    mov     eax,edi
    sub     eax,DWORD PTR [esp+20]
    pop     ebp
    pop     ebx
    pop     edi
    pop     esi
    ret
@@:
    mov     edx,DWORD PTR [ebx]
    xor     eax,eax
@@:
    movzx   ecx,BYTE PTR [edx+eax]
    mov     BYTE PTR [edi+eax],cl
    add     eax,1
    test    cl,cl
    jnz     @b
    mov     edx,1
    lea     edi,[edi+eax-1]
    add     ebx,4
    jmp     _wsp1

wsp ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

END

